#include <iostream>

static int use_stdin = 1;

static int input_file_cursor = 0; // current char looking at
static int input_file_cursor_line = 1;
static int input_file_cursor_col = 0;
static char input_file_cursor_char = 0;
static int input_file_size;
static char* input_file;

char peek_char()
{
    if (use_stdin) {
        return std::cin.peek();
    } else {
        if (input_file_cursor == input_file_size - 1) {
            return EOF;
        }

        return input_file[input_file_cursor];
    }
}

char pop_char()
{
    if (input_file_cursor_char == '\n') {
        input_file_cursor_col = 0;
        input_file_cursor_line++;
    }
    input_file_cursor_col++;

    if (use_stdin) {
        input_file_cursor_char = std::cin.get();
    } else {
        if (input_file_cursor == input_file_size - 1) {
            return EOF;
        }

        input_file_cursor_char = input_file[input_file_cursor];
        input_file_cursor++;
    }

    return input_file_cursor_char;
}
